﻿namespace FlaUI.Core.Definitions
{
    /// <summary>
    /// Represents the visual style of text in a document.
    /// </summary>
    public enum StyleType
    {
        /// <summary>
        /// A list with bulleted items. Supported starting with Windows 8.1.
        /// </summary>
        BulletedList,

        /// <summary>
        /// A custom style.
        /// </summary>
        Custom,

        /// <summary>
        /// Text that is emphasized.
        /// </summary>
        Emphasis,

        /// <summary>
        /// A first level heading.
        /// </summary>
        Heading1,

        /// <summary>
        /// A second level heading.
        /// </summary>
        Heading2,

        /// <summary>
        /// A third level heading.
        /// </summary>
        Heading3,

        /// <summary>
        /// A fourth level heading.
        /// </summary>
        Heading4,

        /// <summary>
        /// A fifth level heading.
        /// </summary>
        Heading5,

        /// <summary>
        /// A sixth level heading.
        /// </summary>
        Heading6,

        /// <summary>
        /// A seventh level heading.
        /// </summary>
        Heading7,

        /// <summary>
        /// An eighth level heading.
        /// </summary>
        Heading8,

        /// <summary>
        /// A ninth level heading.
        /// </summary>
        Heading9,

        /// <summary>
        /// Normal style.
        /// </summary>
        Normal,

        /// <summary>
        /// A list with numbered items. Supported starting with Windows 8.1.
        /// </summary>
        NumberedList,

        /// <summary>
        /// A quotation.
        /// </summary>
        Quote,

        /// <summary>
        /// A subtitle.
        /// </summary>
        Subtitle,

        /// <summary>
        /// A title.
        /// </summary>
        Title
    }
}
